(function () {

  'use strict';

  var csInterface = new CSInterface();
    
csInterface.evalScript('getActivationData()', function(retVal) {  
        if(retVal=="true"){document.getElementById("btnLicense").style.display= "block";}
        else{document.getElementById("btnActivate").style.display= "block";}
      });        
     
//Main UI
    
  document.getElementById('btnLicense').addEventListener('click', function () {
        disableBtns();
        csInterface.evalScript('manageLicense()', function(retVal) {
        enableBtns();    
        if(retVal=="true"){document.getElementById("btnActivate").style.display= "none";document.getElementById("btnLicense").style.display= "block";}
        else{document.getElementById("btnLicense").style.display= "none";document.getElementById("btnActivate").style.display= "block";}
      }); 
      
  });  
    
  document.getElementById('btnActivate').addEventListener('click', function () {
        disableBtns();
        csInterface.evalScript('manageLicense()', function(retVal) {
        enableBtns();    
        if(retVal=="true"){document.getElementById("btnActivate").style.display= "none";document.getElementById("btnLicense").style.display= "block";}
        else{document.getElementById("btnLicense").style.display= "none";document.getElementById("btnActivate").style.display= "block";}
      }); 
      
  });     
    
  document.getElementById('btnDefineHair').addEventListener('click', function () {
        disableBtns();
        csInterface.evalScript('defineHairArea()', function(retVal) {  
        enableBtns();
        document.getElementById("btnContinue").disabled=true;
      }); 
      
  });
    
  document.getElementById('btnSelectSubject').addEventListener('click', function () {
        disableBtns();
        csInterface.evalScript('selectSubject()', function(retVal) { 
        enableBtns();
        document.getElementById("btnContinue").disabled=true;
      });
         
  });
    
  document.getElementById('btnExtraction').addEventListener('click', function () {
        disableBtns();
        csInterface.evalScript('removeBG()', function(retVal) {
        enableBtns();  
      });
         
  });
    
  document.getElementById('btnMerge').addEventListener('click', function () {
        disableBtns();
        csInterface.evalScript('mergeAll()', function(retVal) { 
        enableBtns();    
      });
         
  });  
       
  document.getElementById('btnMagicWand').addEventListener('click', function(){csInterface.evalScript('selectMagicWand()');});
  document.getElementById('btnQuickSelect').addEventListener('click', function(){csInterface.evalScript('selectQuickSelect()');});    
  document.getElementById('btnLasso').addEventListener('click', function(){csInterface.evalScript('selectLasso()');});
  document.getElementById('btnPolygonLasso').addEventListener('click', function(){csInterface.evalScript('selectPolygonalLasso()');});    
  document.getElementById('btnMagneticLasso').addEventListener('click', function(){csInterface.evalScript('selectMagneticLasso()');});
  document.getElementById('btnInvertSelection').addEventListener('click', function(){csInterface.evalScript('invertSelection()');}); 
    
  document.getElementById('btnRunBatch').addEventListener('click', function () {
        document.getElementById("tab1").style.display= "none";     
        document.getElementById("tab2").style.display= "block";
      });
    
  document.getElementById('btnSkipImage').addEventListener('click', function () {
        disableBtns();
        var imagePath=saveFolder+'/'+imageList[imageIndex-1];
        var saveData=[imageList[imageIndex-1],sourceFolder];
        csInterface.evalScript('skipImage("' + saveData + '")'); 
        batchImageOpen=false;
        if(lastImage==true){
            resetBatchUI();
            resetGlobalVars();
            csInterface.evalScript('finish("' + sourceFolder + '")');         
        }
      });    

  document.getElementById('btnContinue').addEventListener('click', function () {
        disableBtns();
        var imagePath=saveFolder+'/'+imageList[imageIndex-1];
        var saveData=[saveFolder,imageList[imageIndex-1],imageList[imageIndex-1],sourceFolder,saveType.value];
        csInterface.evalScript('saveImage("' + saveData + '")', function(retVal){
        batchImageOpen=false; 
        if(lastImage==true){
            resetBatchUI();
            resetGlobalVars();
            csInterface.evalScript('finish("' + sourceFolder + '")');         
        }                                                                                                                                                   
        });         
      });      

  document.getElementById('btnStopBatch').addEventListener('click', function (){resetBatchUI();resetGlobalVars();});
    
//Batch Settings UI   
    
  document.getElementById('btnSourceFolder').addEventListener('click', function () {
        
      
        csInterface.evalScript('getFolder()', function(retVal) {
        var folderData=retVal.split(',');  
        if(folderData[1]==undefined){document.getElementById("sourceFolderName").innerHTML = "No Folder Selected";}
        else{
            sourceFolder=folderData[0];
            folderData[1]=folderData[1].replace(/%20/g,' ');
            folderData[1]=folderData[1].replace(/ZcommaZ/g,',');

            if(folderData[1].length<20){folderData[1]='.../'+folderData[1];}
            else{folderData[1]='...'+folderData[1].substring(folderData[1].length-18,folderData[1].length);}
            document.getElementById("sourceFolderName").innerHTML = folderData[1];
                       
        }
            
            if(document.getElementById('checkBoxSaveInSource').checked==true){
            saveFolder=sourceFolder;
            document.getElementById("saveFolderName").innerHTML = document.getElementById("sourceFolderName").innerHTML; 
            }            
            
        });

      
  }); 
    
    
  document.getElementById('btnSaveFolder').addEventListener('click', function () {
        csInterface.evalScript('getFolder()', function(retVal) {
        var folderData=retVal.split(',');  
        if(folderData[1]==undefined){document.getElementById("saveFolderName").innerHTML = "No Folder Selected";}
        else{
            folderData[1]=folderData[1].replace(/%20/g,' ');
            folderData[1]=folderData[1].replace(/ZcommaZ/g,',');
            saveFolder=folderData[1];
            if(folderData[1].length<20){folderData[1]='.../'+folderData[1];}
            else{folderData[1]='...'+folderData[1].substring(folderData[1].length-18,folderData[1].length);}
            document.getElementById("saveFolderName").innerHTML = folderData[1];
            saveFolder=folderData[0];
            //saveFolder=saveFolder.replace(/ZcommaZ/g,',');
        }
      });
      
      
  });     
    
   document.getElementById('checkBoxSaveInSource').addEventListener('click', function () {
        if(document.getElementById('checkBoxSaveInSource').checked==true){
        document.getElementById("btnSaveFolder").disabled=true;
        saveFolder=sourceFolder;
        document.getElementById("saveFolderName").innerHTML = document.getElementById("sourceFolderName").innerHTML; 
        }
        else{document.getElementById("btnSaveFolder").disabled=false;}
  });   
         
  document.getElementById('btnExitBatch').addEventListener('click', function () {
        document.getElementById("tab2").style.display= "none";      
        document.getElementById("tab1").style.display= "block";      
  });
    
  document.getElementById('btnStartBatch').addEventListener('click', function () {      
        disableBtns();
        startBatch();
      });             
 

    
function disableBtns(){
    document.getElementById("btnDefineHair").disabled = true;  
    document.getElementById("btnSelectSubject").disabled = true; 
    document.getElementById("btnExtraction").disabled = true; 
    document.getElementById('btnMagicWand').disabled = true; 
    document.getElementById('btnQuickSelect').disabled = true;  
    document.getElementById('btnLasso').disabled = true; 
    document.getElementById('btnPolygonLasso').disabled = true; 
    document.getElementById('btnMagneticLasso').disabled = true; 
    document.getElementById('btnInvertSelection').disabled = true; 
    document.getElementById('btnMerge').disabled = true;
    document.getElementById("btnSkipImage").disabled=true;
    document.getElementById("btnContinue").disabled=true;
    document.getElementById("btnRunBatch").disabled=true;
    document.getElementById("btnStopBatch").disabled=true;
    document.getElementById("btnActivate").disabled=true;
    document.getElementById("btnLicense").disabled=true;     
    document.getElementById("processing").style.display= "block";
} 
    
function enableBtns(){
    document.getElementById("processing").style.display= "none";
    document.getElementById("btnDefineHair").disabled = false;  
    document.getElementById("btnSelectSubject").disabled = false; 
    document.getElementById("btnExtraction").disabled = false; 
    document.getElementById('btnMagicWand').disabled = false;
    document.getElementById('btnQuickSelect').disabled = false;  
    document.getElementById('btnLasso').disabled = false; 
    document.getElementById('btnPolygonLasso').disabled = false; 
    document.getElementById('btnMagneticLasso').disabled = false; 
    document.getElementById('btnInvertSelection').disabled = false;
    document.getElementById('btnMerge').disabled = false;
    document.getElementById("btnSkipImage").disabled=false;
    document.getElementById("btnContinue").disabled=false;  
    document.getElementById("btnRunBatch").disabled=false;    
    document.getElementById("btnStopBatch").disabled=false; 
    document.getElementById("btnActivate").disabled=false;
    document.getElementById("btnLicense").disabled=false;    
} 
    
function startBatch(){
var imageListComplete=false;
var saveFolderStatusComplete=false;
var saveFolderWriteOK='false';    

            csInterface.evalScript('getImageList("' + sourceFolder + '")', function(retVal){
            imageList=[];    
            imageList=retVal.split(',');
            for(var i=0;i<imageList.lenght;i++){
                //imageList[i]=imageList[i].replace(/ZcommaZ/g,',');
                imageList[i]=imageList[i].replace(/%20/g,' '); 
            }
            imageListComplete=true;    
            });
    
            csInterface.evalScript('getWriteStatus("' + saveFolder + '")', function(retVal){saveFolderWriteOK=retVal; saveFolderStatusComplete=true;});

            var waitForFolderInfo=setInterval(function(){           
            if(imageListComplete==true&&saveFolderStatusComplete==true){
                clearInterval(waitForFolderInfo);
                if (imageList=='cancel'){enableBtns();}
                else if(imageList.length==0){csInterface.evalScript('noImagesMessage()'); enableBtns();}
                else if(imageList==''){csInterface.evalScript('noImagesMessage()'); enableBtns();}
                else if(saveFolderWriteOK!='true'){csInterface.evalScript('noWriteAccessMessage()'); enableBtns();}
                else{
                    document.getElementById("tab2").style.display= "none";      
                    document.getElementById("tab1").style.display= "block";
                    document.getElementById("btnRunBatch").style.display= "none";
                    document.getElementById("btnStopBatch").style.display= "block";      
                    document.getElementById("btnSkipImage").style.display= "block";
                    document.getElementById("btnContinue").style.display= "block";
                    document.getElementById("batchProgress").style.display= "block"; 
                    startBatch2();
                } 
            } 
            },50);    


    
    
}

  
    
function startBatch2(){    
imageOpenCount=0;
imageIndex=0;
batchStopCommand=false;
batchImageOpen=false;
document.getElementById("step4Header").style.display= "none";
document.getElementById("btnMerge").style.display= "none";  

    var batchCount=setInterval(function(){ 

        csInterface.evalScript('getImageCount()', function(retVal){imageOpenCount=Number(retVal);});
        
        if(imageIndex<imageList.length&&batchImageOpen==false&&batchStopCommand==false){
        batchImageOpen=true;        
        var imagePath=sourceFolder+'/'+imageList[imageIndex];
        imageIndex++;
        document.getElementById("batchProgress").innerHTML = "Batch Progress: Image "+imageIndex+" of "+imageList.length;
        csInterface.evalScript('openImage("' + imagePath + '")', function(retVal){imageOpenCompleted=true;});
            
            var waitForImage=setInterval(function() {           
            if(imageOpenCompleted==true){
                enableBtns();
                document.getElementById("btnContinue").disabled=true;
                imageOpenCompleted=true;
                clearInterval(waitForImage);         
            } 
            },200);
            
        }
        
        if(imageIndex>=imageList.length){lastImage=true; clearInterval(batchCount);}
        else if(batchStopCommand==true){clearInterval(batchCount);}
        
         //alert('hi');                 
    }, 300);  
    
}
    
    
function resetGlobalVars(){   
//sourceFolder=' ';
//saveFolder=' ';
//imageList=[];
batchImageOpen=false;
imageOpenCount=0;
imageIndex=0;
imageOpenCompleted=false;
lastImage=false;
batchStopCommand=true;
}

function resetBatchUI(){
enableBtns();    
document.getElementById("btnSkipImage").disabled=true;
document.getElementById("btnContinue").disabled=true;
document.getElementById("btnStopBatch").style.display= "none";      
document.getElementById("btnSkipImage").style.display= "none"; 
document.getElementById("btnContinue").style.display= "none";     
document.getElementById("btnRunBatch").style.display= "block";
document.getElementById("step4Header").style.display= "block";
document.getElementById("btnMerge").style.display= "block";
document.getElementById("batchProgress").innerHTML=" ";    
document.getElementById("batchProgress").style.display= "none";    
}    

}());

